<script>

//https://www.npmjs.com/package/ytdl-core

import { logObj, logAllProps } from '../util/logutil';
import { timeString } from '../util/display';
import Download, { AUDIOONLY, VIDEOONLY, AUDIOANDVIDEO, VIDEONLY } from '../model/download';
import UrlField from './url-field.vue';
import Format from './format-view.vue';

const { dialog } = require('electron').remote;

const ytdl = require( 'ytdl-core');
const URL = require('url').URL;

const invalidRegex = /[/\\?%*:|"<>]/g;

const path = require('path');

/**
 * Component for selecting Source-video and Dest file for download.
 */
export default {

	props:[],
	data(){

		this.timeString = timeString;
		this.dialog = dialog;
		return {

			// string url entered in text-field before URL verification.
			urlString:'',

			/**
			 * @var {Download} download
			 */
			download:null,

			/**
			 * @var {string} saveName - Local filename to save under.
			 */
			saveName:'new_video',

			/**
			 * @var {string} saveExt - Extension to use when saving file.
			 */
			saveExt:'mp4',

			title:'',

			/**
			 * @var {ytdl.videoInfo}
			 */
			info:null,

			/**
			 * @var {Promise<ytdl.videoInfo>}
			 */
			infoPromise:null,

			channels:AUDIOANDVIDEO,

			/**
			 * @var {Number} playTime - playtime of video being previeed, in seconds.
			 */
			playTime:null
		}

	},
	components:{
		'url-field':UrlField,
		'format':Format
	},
	methods:{

		dlClicked(){
			this.beginDl( this.findFormat() );
		},

		beginDl( fmt ){

			let download = new Download(
				{
					info:this.info,
					path:this.savePath,
					url:this.urlString,
					channels:this.channels,
					title:this.title,
					format:fmt,
					size:0
				}
			);

			this.$emit('download', download );

		},

		/**
		 * Find the best format for the chosen download type.
		 */
		findFormat( ext ) {

			let find;
			if ( this.channels === AUDIOONLY ) find = 'audio';
			else if ( this.channels === VIDEONLY ) find = 'video';
			else return null;

			if ( this.info.formats ) {

				return this.info.formats.find( (v)=>v.type && v.type.slice(0,5).toLowerCase() === this.channels );

			}

		},

		/**
		 *
		 */
		infoLoaded(info) {

			//logObj( info );

			this.info = info;
			this.playTime = info.length_seconds;

			if ( info.title ) {
				let dir = path.dirname( this.savePath );
				let title = info.title.replace( invalidRegex, '' );
				if ( dir.charAt(0) === '.' ) dir = dir.slice(1);
				this.savePath = dir + title + path.extname(this.savePath);
			}
		},

		/**
		 *
		 */
		browseSave() {

			this.dialog.showSaveDialog(
				{
					title:'Save Location',
					defaultPath:this.savePath,
					message:'Choose save location and file name.'
				},
				name=>this.savePath = name
			);
		},

		/**
		 * Load the information for a media link.
		 * @param {URL} url
		 */
		loadUrlInfo( url ) {

			this.infoPromise = ytdl.getInfo( url ).then(
				vidInfo=>this.infoLoaded(vidInfo),
				e=>console.log(e)
			);

		}

	},
	computed:{

		time() {
			return timeString( this.playTime );
		},
		savePath:{

			get() {
				return this.saveName + '.' + this.saveExt;
			},
			set(v) {

				let ind = v.lastIndexOf('.');
				if ( ind >= 0 ) {
					this.saveName = v.slice( 0, ind );
					this.saveExt = v.slice( ind+1 );

				} else this.saveName = v;

			}

		},

		pickChannels:{

			get() { return this.channels; },
			set(v){

				this.channels = v;
				if ( v === AUDIOONLY ) {
					this.saveExt = "mp3";
				} else {
					this.saveExt = "mp4";
				}

			}

		},
		/**
		 * @property {string} pickUrl - url picked in textfield.
		 */
		pickUrl:{

			get(){ return this.urlString },
			set(v) {

				if ( !v ) {
					this.urlString = v;
					return;
				}
				if ( this.urlString == v ) return;

				this.urlString = v;

				//let url = new URL( v );
				this.loadUrlInfo( v );

			}

		}

	}

}
</script>


<template>
	<div class="flex-col">

	<div class="flex-row">
		<div class="input-box">
		<div class="flex-row">
			<input class="url-field" type="url" placeholder="enter video url" v-model="pickUrl">
			<input class="download-button" type="button" :disabled="!info" value="Download" @click="dlClicked">
		</div>
		<div class="flex-row">
			<input type="text" placeholder="save name..." v-model="savePath">
			<input type="button" value="Browse..." @click="browseSave">
		</div>
		</div>

		<div class="thumb-div" v-if="info && info.thumbnail_url"><img :src="info.thumbnail_url"></div>
	</div>

		<div>
		<input :id="elmId('both')" type="radio" value="audioandvideo" checked v-model="pickChannels">
		<label :for="elmId('both')">Audio &amp; Video</label>
		<input :id="elmId('videoOnly')" type="radio" value="videoonly" v-model="pickChannels">
		<label :for="elmId('videoOnly')">Video Only</label>
		<input :id="elmId('audioOnly')" type="radio" value="audioonly" v-model="pickChannels">
		<label :for="elmId('audioOnly')">Audio Only</label>
		</div>

		<div v-if="info">
			Play Time: {{ this.time }}<br>

			<div v-if="info.formats!=null">
				<format v-for="(f,ind) in info.formats" :format="f" :key="ind" @download="beginDl" />
			</div>

		</div>

	</div>

</template>
